#include <bits/stdc++.h>

int main() {
    freopen("stones.in", "r", stdin);
    freopen("stones.out", "w", stdout);
    int n, k;
    scanf("%d%d", &n, &k);
    std::vector<bool> have_stone(n + 1, false);
    have_stone[0] = true;
    for (int i = 0; i < k; i++) {
        int x;
        scanf("%d", &x);
        have_stone[x] = true;
    }
    std::vector<int> dp(n + 1, (int)1e9);
    std::vector<int> pr(n + 1);
    dp[0] = 0;
    pr[0] = -1;
    for (int i = 1; i <= n; i++) {
        pr[i] = -1;
        if (have_stone[i - 1] && dp[i] >= dp[i - 1] + 1) {
            dp[i] = dp[i - 1] + 1;
            pr[i] = 1;
        }
        if (i > 1 && have_stone[i - 2] && dp[i] > dp[i - 2] + 1) {
            dp[i] = dp[i - 2] + 1;
            pr[i] = 2;
        }
    }
    if (dp[n] == (int)1e9) {
        puts("-1");
        return 0;
    }
    int x = n;
    std::vector<int> answer;
    while (pr[x] != -1) {
        answer.push_back(pr[x]);
        x -= pr[x];
    }
    std::reverse(answer.begin(), answer.end());
    printf("%d\n", (int)answer.size());
    for (size_t i = 0; i < answer.size(); i++) {
        printf("%d", answer[i]);
    }
    puts("");
    return 0;
}